LeetCode力扣每日一题(Java):1、两数之和

一、题目

二、解题思路

方法一:暴力枚举

这是最容易想到的一种方法,本质就是二重循环遍历数组,话不多说直接上代码

java 复制代码
public int[] twoSum(int[] nums, int target) {
        for (int i = 0; i < nums.length - 1; i++) {
            for (int j = i + 1; j < nums.length; j++) {
                if(nums[i] + nums[j] == target){
                    return new int[]{i, j};
                }
            }
        }
        return new int[]{};
    }

虽说这种方法简单,但在解题过程中我还是感到自己java基础的不牢。比如我一开始if中的代码是这样写的:

int\[\] arr = { i,j };

return arr;

后来发现可以直接return new int\[\]{i, j};

而且我一开始没有在for循环外面写return new int\[\]{}; 导致代码编译出错,报错提示是:缺少返回值

看来要打算法竞赛我还是任重而道远的

方法二:哈希表

这是一种我从没接触过的方法,而且数据结构基本上忘光了(偷笑)

所以我们首先回顾一下什么是哈希表:简单来说就是通过hash函数将关键字的值映射到对应的存储地址中。常用的哈希函数方法有直接定址法、除留余数法等,定址时还涉及到哈希冲突的解决。

再看力扣官方题解

注意到方法一的时间复杂度较高的原因是寻找 target - x 的时间复杂度过高。因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。

使用哈希表,可以将寻找 target - x 的时间复杂度降低到从 O(N)降低到 O(1)。

这样我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target - x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。

作者:力扣官方题解

链接:https://leetcode.cn/problems/two-sum/

来源:力扣(LeetCode)

著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。

java 复制代码
class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
        for (int i = 0; i < nums.length; ++i) {
            if (hashtable.containsKey(target - nums[i])) {
                return new int[]{hashtable.get(target - nums[i]), i};
            }
            hashtable.put(nums[i], i);
        }
        return new int[0];
    }
}

作者:力扣官方题解
链接:https://leetcode.cn/problems/two-sum/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。

好家伙,你一波操作猛如虎,而我愣是没看懂......好吧,看来确实没学扎实,只能一个一个概念去学了

此处省略很多时间,太多要学的啦

了解完各个概念之后,我们给这段代码打上详细的注释

java 复制代码
class Solution {
    public int[] twoSum(int[] nums, int target) {
        // 创建一个哈希表,用于存储元素和索引的映射关系
        Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
        
        // 遍历数组中的每个元素
        for (int i = 0; i < nums.length; ++i) {
            // 计算目标值与当前元素的差值
            int complement = target - nums[i];
            
            // 如果哈希表中存在差值,则返回结果
            if (hashtable.containsKey(complement)) {
                // 返回两个元素的索引
                return new int[]{hashtable.get(complement), i};
            }
            
            // 将当前元素和索引加入哈希表
            hashtable.put(nums[i], i);
        }
        
        // 如果没有找到符合条件的两个元素,返回空数组
        return new int[0];
    }
}
相关推荐
生态学者4 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
lsswear5 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
考研保研资料分享6 小时前
2022编辑出版跨保西北大学中国史:五校面试与九月补材料
面试·职场和发展
Data analyse4567 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
员工风险管理实务7 小时前
职务侵占有什么价值?岗位关联性与必要性判断
职场和发展
Navigator_Z8 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil2088 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年8 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构
牧羊人.3339 小时前
计算机视觉基础 第16章|EigenFace,FisherFace,LBPH传统人脸识别算法
人工智能·算法·计算机视觉
考研保研资料分享9 小时前
双非新闻学保研复盘:东华小组展示、长安面试与兰大预推免
面试·职场和发展